(*
**
** GENERAL.INC, Genral support routines for SYSINFO.
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 16-Apr-1996
** Last update : 16-Apr-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function HexByte(Number: Byte): String;
Var HChar : Char;
    LChar : Char;
Begin;
 LChar := Chr((Number And $F) + 48);
 If LChar > '9' Then
      LChar := Chr(Ord(LChar) + 7);
 HChar := Chr((Number shr 4) + 48);
 If HChar > '9' Then
      HChar := Chr(Ord(HChar) + 7);
 HexByte := HChar + LChar;
 End; { func. HexByte }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function HexWord(Number: Word): String;
Begin;
HexWord := HexByte(Number Shr 8) + HexByte(Number And $FF);
End; { func. HexWord }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function HexLong(Number: LongInt): String;
Type WordRec = Record
                 Lo : Word;
                 Hi : Word;
               End; { record }
Begin;
HexLong := HexWord(WordRec(Number).Hi) + HexWord(WordRec(Number).Lo);
End; { func. HexLong }
            
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function FVal(S: String): LongInt;
Var Code        : Integer;
    Number      : LongInt;
Begin;
 Val(S,Number,Code);
 If Code<>0 then Number:=0;
  FVal:=Number;
End; { func. FVal }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function  FStr (N : LongInt) : String; {Convert integer to string}
Var Temp : String;
Begin;
 Str(n,temp);
 FStr:=Temp;
End; { func. FStr }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Trim(S:String):String;
Begin;
 While (S[1]=' ') AND (Length(S)>1) Do Delete(S,1,1);
 While (S[Length(S)]=' ') AND (Length(S)>1) Do Delete(S,Length(s),1);
 Trim := S;
End; { func. Trim }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function NoCarry(Regs: Registers): Boolean;
Begin;
 NoCarry := Regs.Flags and FCarry = $0000;
End; { func. NoCarry }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure SetBit(Var Number : Byte; Bit : Byte);
Begin
  Number := Number OR (1 SHL Bit);
End; { proc. SetBit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ClearBit(Var Number : Byte; Bit : Byte);
Begin
  Number := Number AND NOT (1 SHL Bit);
End; { proc. ClearBit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ReadBit(Number, Bit : Byte) : Boolean;
Begin
  ReadBit := (Number AND (1 SHL Bit)) <> 0;
End; { func. ReadBit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Bit2Str(Bits, Nr:Byte):String;
Begin;
 If ReadBit(Bits, Nr) then Bit2Str:='Yes'
   Else Bit2Str:='No ';
End; { func. Bit2Str }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Bit2oN(Bits, Nr:Byte):String;
Begin;
 If ReadBit(Bits, Nr) then Bit2On:='On '
   Else Bit2On:='Off';
End; { func. Bit2On }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Bool2oN(B:Boolean):String;
Begin;
 If B then Bool2On:='On '
   Else Bool2On:='Off';
End; { func. Bool2On }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Bool2Str(B:Boolean):String;
Begin;
 If B then Bool2Str:= 'Yes'
   Else Bool2Str:= 'No ';
End; { func. Bool2On }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function SUpcase(S:String):String;
Var Len:Byte;
Begin;
 For Len := 01 to Length(S) do
  S[len] := UpCase(S[Len]);
 SUpcase := S;
End; { func. SUpcase }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function UnBCD(B: Byte): Byte;
Begin;
 UnBCD := (B AND $0F) + ((B SHR 4) * 10)
End; { func. UnBCD }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ByteToWord(a, b : Byte): Word;
Begin;
 ByteToWord := Word(B) SHL 8 + A;
End; { ByteToWord }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Dup(CH:Char; Times:Byte):String;
Var Temp   : String;
    Teller : Byte;
Begin;
 Temp := '';
 For Teller:=01 to Times do Temp:=Temp+CH;
 Dup := Temp;
End; { func. Dup }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure Initialize;
Begin;
 { Get Country information }
  Regs.AH := $38;
  Regs.AL := $00;
  Regs.DS := Seg(Country);
  Regs.DX := Ofs(Country);
  Intr($21, Regs);
  CountryCode := Regs.BX;
 { Country information gathered }

 OsMajor := Lo(DosVersion);
 OsMinor := Hi(DosVersion);

 { Get address of InDosFlag }
  Regs.AH := $34;
  Intr($21, Regs);
  DosCSeg := Regs.ES;
  DosCOfs := Regs.BX;
 { InDosFlag gathered }

 { Get List Of List }
  Regs.AH := $52;
  Intr($21, Regs);
  DevSeg := Regs.ES;
  DevOfs := Regs.BX;
 { List Of List Information gathered }

 { Get Equipment byte }
  Intr($11, Regs);
  Equip := Regs.AX
 { Equipment info gathered }
End; { proc. Initialize }
